﻿using FluentValidation;
using Hotline.Validators.BatchTask;

namespace Hotline.BatchTask;

public class ApptaskDomainService : IApptaskDomainService
{
    /// <summary>
    /// 新增任务
    /// </summary>
    public Task<string> AddAsync(Apptask apptask, CancellationToken cancellation)
    {
        var validator = new ApptaskValidator();
        var result = validator.Validate(apptask);
        if (!result.IsValid)
            throw new ValidationException(result.Errors.FirstOrDefault()?.ErrorMessage);

        if(string.IsNullOrEmpty(apptask.Name))
            apptask.CreateName();


        //todo 1.参数校验，
        //2. 任务名称可选：依据任务类型生成 3.类型、次数上限由主表冗余到明细
        throw new NotImplementedException();
    }

    /// <summary>
    /// 查询任务进度
    /// </summary>
    /// <returns></returns>
    public Task<ApptaskProgress> GetProgressAsync(string taskId, CancellationToken cancellation)
    {
        throw new NotImplementedException();
    }

    /// <summary>
    /// 终止任务
    /// </summary>
    /// <param name="taskId"></param>
    /// <param name="cancellation"></param>
    /// <returns></returns>
    public Task TerminalTaskAsync(string taskId, CancellationToken cancellation)
    {
        throw new NotImplementedException();
    }

    /// <summary>
    /// 获取一个待执行的任务
    /// </summary>
    /// <param name="cancellation"></param>
    /// <returns></returns>
    public Task<ApptaskItem> GetWaitingTaskAsync(CancellationToken cancellation)
    {
        // 1. 乐观锁 2.待执行 或 失败并且次数未到上限的
        throw new NotImplementedException();
    }

    /// <summary>
    /// 执行任务
    /// </summary>
    /// <param name="executor"></param>
    /// <param name="cancellation"></param>
    /// <returns></returns>
    public Task ExecuteAsync(IApptaskExecutor executor, CancellationToken cancellation)
    {
        // try catch到ex或返回fail的执行失败，返回成功的执行成功
        throw new NotImplementedException();
    }
}