﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Hotline.BatchTask
{
    public interface IApptaskDomainService
    {
        /// <summary>
        /// 新增任务
        /// </summary>
        Task<string> AddAsync(Apptask apptask, CancellationToken cancellation);

        /// <summary>
        /// 查询任务进度
        /// </summary>
        /// <returns></returns>
        Task<ApptaskProgress> GetProgressAsync(string taskId, CancellationToken cancellation);

        /// <summary>
        /// 终止任务
        /// </summary>
        /// <param name="taskId"></param>
        /// <param name="cancellation"></param>
        /// <returns></returns>
        Task TerminalTaskAsync(string taskId, CancellationToken cancellation);

        /*job request*/
        /// <summary>
        /// 获取一个待执行的任务
        /// </summary>
        /// <param name="cancellation"></param>
        /// <returns></returns>
        Task<ApptaskItem> GetWaitingTaskAsync(CancellationToken cancellation);

        /// <summary>
        /// 执行任务
        /// </summary>
        /// <param name="executor"></param>
        /// <param name="cancellation"></param>
        /// <returns></returns>
        Task ExecuteAsync(IApptaskExecutor executor, CancellationToken cancellation);
    }

    /// <summary>
    /// 任务进度
    /// </summary>
    public class ApptaskProgress
    {
        public int Total { get; set; }
        public int Waiting { get; set; }
        public int Processing { get; set; }
        public int Success { get; set; }
        public int Fail { get; set; }
    }
}
